`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:32:36 05/26/2016 
// Design Name: 
// Module Name:    RAM_ctl 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module RAM_ctl(
	change,
	second1,
	second0,
	minute1,
	minute0,
	hour1,
	hour0,
	day1, 
	day0, 
	month1,
	month0,
	year1,
	year0,
	clk, // global clock
	rst_n, //active low reset
	en,
	data_out,
	data_valid
);

  
  input change;
  input [3:0] second1, second0; //for second
  input [3:0] minute1, minute0; //for day
  input [3:0] hour1, hour0; //for hour
  input [3:0] day1, day0; //for day
  input [3:0] month1, month0; //for month
  input [3:0] year1, year0; //for year
  input clk; // global clock signal
  input rst_n; // low active reset
  input en;
  output reg [7:0] data_out;
  output reg data_valid;

  parameter mark0 = 256'h0000_3ffc_3ffc_300c_300c_300c_300c_300c_300c_300c_300c_300c_300c_3ffc_3ffc_0000;
  parameter mark1 = 256'h0000_000c_000c_000c_000c_000c_000c_000c_000c_000c_000c_000c_000c_000c_000c_0000;
  parameter mark2 = 256'h0000_3ffc_3ffc_000c_000c_000c_000c_3ffc_3ffc_3000_3000_3000_3000_3ffc_3ffc_0000;
  parameter mark3 = 256'h0000_3ffc_3ffc_000c_000c_000c_000c_3ffc_3ffc_000c_000c_000c_000c_3ffc_3ffc_0000;
  parameter mark4 = 256'h0000_300c_300c_300c_300c_300c_300c_3ffc_3ffc_000c_000c_000c_000c_000c_000c_0000;
  parameter mark5 = 256'h0000_3ffc_3ffc_3000_3000_3000_3000_3ffc_3ffc_000c_000c_000c_000c_3ffc_3ffc_0000;
  parameter mark6 = 256'h0000_3ffc_3ffc_3000_3000_3000_3000_3ffc_3ffc_300c_300c_300c_300c_3ffc_3ffc_0000;
  parameter mark7 = 256'h0000_3ffc_3ffc_000c_000c_000c_000c_000c_000c_000c_000c_000c_000c_000c_000c_0000;
  parameter mark8 = 256'h0000_3ffc_3ffc_300c_300c_300c_300c_3ffc_3ffc_300c_300c_300c_300c_3ffc_3ffc_0000;
  parameter mark9 = 256'h0000_3ffc_3ffc_300c_300c_300c_300c_3ffc_3ffc_000c_000c_000c_000c_3ffc_3ffc_0000;
  parameter mark10 = 256'h0180_0660_0c30_1818_300c_6006_7ffe_7ffe_6006_6006_6006_6006_6006_6006_6006_6006;//A
  parameter mark11 = 256'h3ff0_3ff8_300c_3006_300c_300c_3ff8_3ff0_3000_3000_3000_3000_3000_3000_3000_3000;//P
  parameter mark12 = 256'h6006_700e_781e_6c36_6666_63c6_6186_6006_6006_6006_6006_6006_6006_6006_6006_6006;//M
  parameter IDLE  = 2'd0;
  parameter WRITE = 2'd1;
  parameter GETDATA = 2'd2;
  parameter TRANSDATA = 2'd3;

  reg [5:0] addr, addr_next;
  reg [5:0] counter_word, counter_word_next;
  wire [63:0] data_out_64;
  reg [63:0] data_in;
  reg [15:0] in_temp0, in_temp1, in_temp2, in_temp3;
  reg [1:0] cnt, cnt_next;  //count mark row
  reg [511:0] mem, mem_next;
  reg [1:0] state, state_next;
  reg flag, flag_next;
  reg [7:0] data_out_next;
  reg data_valid_next;
  reg wen, wen_next;
  reg temp_change, temp_change_next;
  reg [15:0] second0_tmp,second1_tmp,minute0_tmp,minute1_tmp,day0_tmp,day1_tmp,month0_tmp,month1_tmp,hour0_tmp,hour1_tmp,year0_tmp,year1_tmp;


	
	always@*
		case(second0)
			4'd0: second0_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: second0_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: second0_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: second0_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: second0_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: second0_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: second0_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: second0_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: second0_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: second0_tmp = mark9[(240-((addr%16)*16))+:16];
			default: second0_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase
		
	always@*
		case(second1)
			4'd0: second1_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: second1_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: second1_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: second1_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: second1_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: second1_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: second1_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: second1_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: second1_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: second1_tmp = mark9[(240-((addr%16)*16))+:16];
			default: second1_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase
	
	always@*
		case(minute0)
			4'd0: minute0_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: minute0_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: minute0_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: minute0_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: minute0_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: minute0_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: minute0_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: minute0_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: minute0_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: minute0_tmp = mark9[(240-((addr%16)*16))+:16];
			default: minute0_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase
		
	always@*
		case(minute1)
			4'd0: minute1_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: minute1_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: minute1_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: minute1_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: minute1_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: minute1_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: minute1_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: minute1_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: minute1_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: minute1_tmp = mark9[(240-((addr%16)*16))+:16];
			default: minute1_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase

	always@*
		case(hour0)
			4'd0: hour0_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: hour0_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: hour0_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: hour0_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: hour0_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: hour0_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: hour0_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: hour0_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: hour0_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: hour0_tmp = mark9[(240-((addr%16)*16))+:16];
			default: hour0_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase

	always@*
		case(hour1)
			4'd0: hour1_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: hour1_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: hour1_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: hour1_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: hour1_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: hour1_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: hour1_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: hour1_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: hour1_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: hour1_tmp = mark9[(240-((addr%16)*16))+:16];
			default: hour1_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase
	
	always@*
		case(day0)
			4'd0: day0_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: day0_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: day0_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: day0_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: day0_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: day0_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: day0_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: day0_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: day0_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: day0_tmp = mark9[(240-((addr%16)*16))+:16];
			default: day0_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase

	always@*
		case(day1)
			4'd0: day1_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: day1_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: day1_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: day1_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: day1_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: day1_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: day1_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: day1_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: day1_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: day1_tmp = mark9[(240-((addr%16)*16))+:16];
			default: day1_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase
	
	always@*
		case(month0)
			4'd0: month0_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: month0_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: month0_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: month0_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: month0_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: month0_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: month0_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: month0_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: month0_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: month0_tmp = mark9[(240-((addr%16)*16))+:16];
			default: month0_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase

	always@*
		case(month1)
			4'd0: month1_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: month1_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: month1_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: month1_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: month1_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: month1_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: month1_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: month1_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: month1_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: month1_tmp = mark9[(240-((addr%16)*16))+:16];
			default: month1_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase
	always@*
		case(year0)
			4'd0: year0_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: year0_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: year0_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: year0_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: year0_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: year0_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: year0_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: year0_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: year0_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: year0_tmp = mark9[(240-((addr%16)*16))+:16];
			default: year0_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase

	always@*
		case(year1)
			4'd0: year1_tmp = mark0[(240-((addr%16)*16))+:16];
			4'd1: year1_tmp = mark1[(240-((addr%16)*16))+:16];
			4'd2: year1_tmp = mark2[(240-((addr%16)*16))+:16];
			4'd3: year1_tmp = mark3[(240-((addr%16)*16))+:16];
			4'd4: year1_tmp = mark4[(240-((addr%16)*16))+:16];
			4'd5: year1_tmp = mark5[(240-((addr%16)*16))+:16];
			4'd6: year1_tmp = mark6[(240-((addr%16)*16))+:16];
			4'd7: year1_tmp = mark7[(240-((addr%16)*16))+:16];
			4'd8: year1_tmp = mark8[(240-((addr%16)*16))+:16];
			4'd9: year1_tmp = mark9[(240-((addr%16)*16))+:16];
			default: year1_tmp = mark0[(240-((addr%16)*16))+:16];
		endcase
	
	
	always@*
		case(cnt)
			2'd3:
				begin
					in_temp0 = 16'd0;
					in_temp1 = 16'd0;
					in_temp2 = year1_tmp;
					in_temp3 = year0_tmp;
				end
			2'd2:
				begin
					in_temp0 = month1_tmp;
					in_temp1 = month0_tmp;
					in_temp2 = day1_tmp;
					in_temp3 = day0_tmp;
				end
			2'd1:
				begin
					in_temp0 = 16'd0;
					in_temp1 = 16'd0;
					in_temp2 = hour1_tmp;
					in_temp3 = hour0_tmp;
				end			
			2'd0:
				begin
					in_temp0 = minute1_tmp;
					in_temp1 = minute0_tmp;
					in_temp2 = second1_tmp;
					in_temp3 = second0_tmp;
				end
			
		endcase

  RAM R1(
    .clka(clk),
    .wea(wen),
    .addra(addr),
    .dina(data_in),
    .douta(data_out_64)
  );

  always @(posedge clk or negedge rst_n) begin
    if (!rst_n) begin
      addr = 6'd0;
      cnt = 2'd0;
      mem = 512'd0;
      state = IDLE;
      flag = 1'b0;
      counter_word = 6'd0;
      data_out = 8'd0;
      data_valid = 1'd0;
      wen = 1'b1;
      temp_change = 1'b0;
    end else begin
      addr = addr_next;
      cnt = cnt_next;
      mem = mem_next;
      state = state_next;
      flag = flag_next;
      counter_word = counter_word_next;
      data_out = data_out_next;
      data_valid = data_valid_next;
      wen = wen_next;
      temp_change = temp_change_next;
    end
  end

  always @(*) begin
    state_next = state;
    case(state)
      IDLE: begin
        if (wen) begin
          state_next = WRITE;
        end else begin
          state_next = GETDATA;
        end
      end
      WRITE: begin
        if (addr == 6'd63) begin
          state_next = GETDATA;
        end
      end
      GETDATA: begin
        if (flag == 1'b1) begin
          state_next = TRANSDATA;
        end
      end
      TRANSDATA: begin
        if (addr == 6'd0 && counter_word == 6'd63 && en) begin
          state_next = IDLE;
        end else if (counter_word == 6'd63 && en) begin
          state_next = GETDATA;
        end
      end
    endcase
  end

  always @(*) begin
    addr_next = addr;
    data_in = 64'd0;
    cnt_next = cnt;
    mem_next = mem;
    flag_next = 1'b0;
    counter_word_next = counter_word;
    data_valid_next = 1'd0;
    data_out_next = 8'd0;
    case(state)
      WRITE: begin
        addr_next = addr + 1'b1;
        data_in = {in_temp0, in_temp1, in_temp2, in_temp3};
        if (addr == 6'd15 || addr == 6'd31 || addr == 6'd47 || addr == 6'd63) begin
          cnt_next = cnt + 1'd1;
        end
      end
      GETDATA: begin
        if (!flag) begin
          addr_next = addr + 1'b1;
        end
        if ((addr%8) == 6'd7) begin
          flag_next = 1'b1;
        end
        if ((addr%8) >= 6'd1 || flag) begin
          mem_next[(((addr-1)%8)*64)+:64] = data_out_64;
        end
      end
      TRANSDATA: begin
        if (en) begin
          counter_word_next = counter_word + 1'b1;
          data_valid_next = 1'b1;
          data_out_next = {mem[511 - counter_word],
            mem[447 - counter_word],
            mem[383 - counter_word],
            mem[319 - counter_word],
            mem[255 - counter_word],
            mem[191 - counter_word],
            mem[127 - counter_word],
            mem[63 - counter_word]};
        end
      end
    endcase
  end
 
  //wen control
  always @(*) begin
    wen_next = wen;
    temp_change_next = temp_change;
    if (change) begin
      temp_change_next = 1'b1;
    end
    if (state == WRITE && addr == 6'd63) begin
      wen_next = 1'b0;
    end
    if (state == TRANSDATA && addr == 6'd0 && counter_word == 6'd63 && temp_change == 1'b1) begin
      temp_change_next = 1'b0;
      wen_next = 1'b1;
    end
  end


endmodule
