`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:48:33 05/26/2016 
// Design Name: 
// Module Name:    lab12_1 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module lab12_1(
    input              clk,
  input              rst_n,
  output             LCD_rst,
  output wire [1:0]  LCD_cs,
  output             LCD_rw,
  output             LCD_di,
  output wire [7:0]  LCD_data,
  output             LCD_en
);

  wire [3:0]second1,second0,minute1,minute0,hour1,hour0,day1,day0,month1,month0,year1,year0;
  wire en,out_valid;
  wire [7:0] data_out;
  wire clk_div;
  wire clk_d;


  freq_div U0(
    .clk_out(clk_d),
    .clk_ctl(),
    .clk(clk),
    .rst_n(rst_n)
    );
	 
	counter U1(	
	.second1(second1),
	.second0(second0),
	.minute1(minute1),
	.minute0(minute0),
	.hour1(hour1),
	.hour0(hour0),
	.day1(day1), 
	.day0(day0), 
	.month1(month1),
	.month0(month0),
	.year1(year1),
	.year0(year0),
	.clk(clk_d), // global clock signal
	.rst_n(rst_n) // low active reset
	);
	 
	

  RAM_ctl U2 (
    .clk(clk_div),
    .rst_n(rst_n),
    .change(clk_d),
    .second1(second1),
	 .second0(second0),
	 .minute1(minute1),
	 .minute0(minute0),
	 .hour1(hour1),
	 .hour0(hour0),
	 .day1(day1), 
	 .day0(day0), 
	 .month1(month1),
	 .month0(month0),
	 .year1(year1),
	 .year0(year0),
    .en(en),
    .data_out(data_out),
    .data_valid(out_valid));

  lcd_ctl U3 (
    .clk(clk_div),
    .rst_n(rst_n),
    .data(data_out),           // memory value  
    .data_valid(out_valid),    // if data_valid = 1 the data is valid
    .LCD_di(LCD_di),
    .LCD_rw(LCD_rw),
    .LCD_en(LCD_en),
    .LCD_rst(LCD_rst),
    .LCD_cs(LCD_cs),
    .LCD_data(LCD_data),
    .en_tran(en)
  );

  ct_clkdivider #(
    .half_cycle(200),         // half cycle = 200 (divided by 400)
    .counter_width(8)         // counter width = 8 bits
  ) clk100K (
    .rst_n(rst_n),
    .clk(clk),
    .clk_div(clk_div)
  );


endmodule
